
function vexalarm_Design_buildFrames()
	for key,val in pairs(vexalarm.frames) do
		if vexalarm_f_data[key] == nil then
			val:Hide()
			vexalarm.frames[key] = nil
		end
	end
	
	for key in pairs(vexalarm_f_data) do
		if vexalarm.frames[key] == nil then
			vexalarm.frames[key] = CreateFrame("Frame", nil, UIparent)
			vexalarm.last_spell_id[key] = ""
			vexalarm.last_spell_timestamp[key] = 0
			vexalarm.last_spell_event[key] = ""
			vexalarm.last_spell_caster[key] = ""
			
			vexalarm.proclaims[key] = {}
			vexalarm.proclaimPlaces[key] = {}
			
			vexalarm.totemsPlaced[key] = {}
		end
		vexalarm_Design_setFrame(key)
		
	end
end

function vexalarm_Design_setFrame(frame)
	vexalarm.frames[frame]:SetWidth(vexalarm_f_data[frame]["design"]["size"]["width"])
	vexalarm.frames[frame]:SetHeight(vexalarm_f_data[frame]["design"]["size"]["height"])
	
	vexalarm.frames[frame]:SetFrameStrata("LOW")
	vexalarm.frames[frame]:SetPoint(
		vexalarm_f_data[frame]["design"]["position"]["bg"]["frameanchor"],
		UIParent,
		vexalarm_f_data[frame]["design"]["position"]["bg"]["anchor"],
		vexalarm_f_data[frame]["design"]["position"]["bg"]["x"],
		vexalarm_f_data[frame]["design"]["position"]["bg"]["y"])
		
	vexalarm.frames[frame]:SetBackdrop({
		bgFile=vexalarm.LSM:Fetch("background", vexalarm_f_data[frame]["design"]["bg"]["texture"]),
		edgeFile=vexalarm.LSM:Fetch("border", vexalarm_f_data[frame]["design"]["border"]["texture"]),
		tile=false,
		edgeSize=vexalarm_f_data[frame]["design"]["border"]["size"]})
	
	if (vexalarm.testmode and vexalarm.testmode_recolor) or not(vexalarm.testmode) or vexalarm_Testmode_newBGcolors[frame]==nil then
		vexalarm.frames[frame]:SetBackdropColor(
			vexalarm_f_data[frame]["design"]["bg"]["color"]["r"],
			vexalarm_f_data[frame]["design"]["bg"]["color"]["g"],
			vexalarm_f_data[frame]["design"]["bg"]["color"]["b"],
			vexalarm_f_data[frame]["design"]["bg"]["color"]["a"])
			
		vexalarm.frames[frame]:SetBackdropBorderColor(
			vexalarm_f_data[frame]["design"]["border"]["color"]["r"],
			vexalarm_f_data[frame]["design"]["border"]["color"]["g"],
			vexalarm_f_data[frame]["design"]["border"]["color"]["b"],
			vexalarm_f_data[frame]["design"]["border"]["color"]["a"])
	else
		vexalarm.frames[frame]:SetBackdropColor(
			vexalarm_Testmode_newBGcolors[frame]["bg"][1],
			vexalarm_Testmode_newBGcolors[frame]["bg"][2],
			vexalarm_Testmode_newBGcolors[frame]["bg"][3], 0.5)
			
		vexalarm.frames[frame]:SetBackdropBorderColor(
			vexalarm_Testmode_newBGcolors[frame]["border"][1],
			vexalarm_Testmode_newBGcolors[frame]["border"][2],
			vexalarm_Testmode_newBGcolors[frame]["border"][3], 0.5)
	end
	vexalarm.frames[frame]:RegisterForDrag("LeftButton")
	vexalarm.frames[frame]:SetScript("OnDragStart", function () vexalarm.frames[frame]:StartMoving() end)
	vexalarm.frames[frame]:SetScript("OnDragStop", function (self)
		self:StopMovingOrSizing()
		vexalarm_Design_savePosition(frame)
		end)
end

function vexalarm_Design_toggleMovable(val)
	for key in pairs(vexalarm.frames) do
		if vexalarm.frames[key] ~= nil then
			vexalarm.frames[key]:SetMovable(val)
			vexalarm.frames[key]:EnableMouse(val)
		end
	end
end

function vexalarm_Design_savePosition(frame)
	if vexalarm_f_data[frame]~= nil then
		vexalarm_f_data[frame]["design"]["position"]["bg"]["frameanchor"] = select(1, vexalarm.frames[frame]:GetPoint())
		vexalarm_f_data[frame]["design"]["position"]["bg"]["anchor"] = select(3, vexalarm.frames[frame]:GetPoint())
		vexalarm_f_data[frame]["design"]["position"]["bg"]["x"] = select(4, vexalarm.frames[frame]:GetPoint())
		vexalarm_f_data[frame]["design"]["position"]["bg"]["y"] = select(5, vexalarm.frames[frame]:GetPoint())
	end
end