vexalarm_Testmode_Spells = {}
vexalarm_Testmode_Frames = 0

function vexalarm_Testmode_handler(val)
	vexalarm.testmode = val
	
	if val then
		vexalarm_TestMode_collectFrameSpells()
		vexalarm_Testmode_ani()
		vexalarm.testmode_recolor = false
	end
	vexalarm_Design_toggleMovable(val)
	vexalarm_Testmode_toggleFontFrames()
	vexalarm_Testmode_recolorFrameBGs()
end

function vexalarm_Testmode_nonAniFuncs()
	if vexalarm.testmode then
		vexalarm_Design_toggleMovable(val)
		vexalarm_Testmode_toggleFontFrames()
		vexalarm_Testmode_recolorFrameBGs()
	end
end

function vexalarm_Testmode_getRndSpell(frame)
	local returnvalue = nil
	local rnd = 1
	
	if vexalarm_Testmode_Spells[frame] ~= nil then
		if #vexalarm_Testmode_Spells[frame] > 0 then
			rnd = math.random(1,#vexalarm_Testmode_Spells[frame])
			returnvalue = vexalarm_Testmode_Spells[frame][rnd]
		end
	end
	
	return returnvalue
end

function vexalarm_Testmode_getRndFrame()
	local returnvalue = nil
	local rnd = 1
	
	if vexalarm_Testmode_Spells ~= nil then
		if vexalarm_Testmode_Frames > 0 then
			rnd = math.random(1,vexalarm_Testmode_Frames)
			local counter = 0
			for frame in pairs(vexalarm_Testmode_Spells) do
				counter = counter + 1
				if counter == rnd then
					returnvalue = frame
				end
			end
		end
	end
	
	return returnvalue
end

function vexalarm_TestMode_collectFrameSpells()
	vexalarm_Testmode_Spells = {}
	vexalarm_Testmode_Frames = 0
	for key in pairs(vexalarm_spells_defaults) do
		for frame,framedata in pairs(vexalarm_f_data) do
			if vexalarm_Testmode_Spells[frame] == nil then
				vexalarm_Testmode_Spells[frame] = {}
				vexalarm_Testmode_Frames = vexalarm_Testmode_Frames + 1
			end
			
			local check = false
			
			if framedata["spelldata"]["useprofile"] and vexalarm_sp[framedata["spelldata"]["spellprofile"]] ~= nil then
				if vexalarm_sp[framedata["spelldata"]["spellprofile"]][key] ~= nil then
					for i=1,4 do
						if vexalarm_sp[framedata["spelldata"]["spellprofile"]][key][i] then
							check = true
						end
					end
				end
			elseif not(vexalarm_f_data[frame]["spelldata"]["useprofile"]) then
				if vexalarm_s[key] ~= nil then
					for i=1,4 do
						if vexalarm_s[key][i] then
							check = true
						end
					end
				end
			end
			
			if check then
				vexalarm_Testmode_Spells[frame][#vexalarm_Testmode_Spells[frame]+1] = key
			end
		end
	end
end

function vexalarm_Testmode_proclaim()
	if vexalarm.testmode then
		local names = {"DaKiller", "UberPvpler", "KingCarl", "OmfgRoflLol", "TreeHugger", "Sporty", "Darlene", "Karin", "Dave", "Don", "Wulf", "Talric", "Gonzalez", "Sarisse", "Toren"}
		local caster = names[math.random(1,#names)]
		local target = caster
		
		while target == caster do
			target = names[math.random(1,#names)]
		end
		
		local rndFrame = vexalarm_Testmode_getRndFrame()
	
		if rndFrame ~= nil then
			local spellid = vexalarm_Testmode_getRndSpell(rndFrame)
			if spellid ~= nil then
				for frame in pairs(vexalarm_Testmode_Spells) do
					local alarmtype = vexalarm_spells_defaults[spellid][6]
					local spellname = select(1, GetSpellInfo(tonumber(spellid)))
					local eventchar = ""
					local lossEvent = false
					if vexalarm_spells_defaults[spellid][6][7] ~= nil then
						eventchar = "SPELL_SUMMON"
						lossEvent = true
					elseif vexalarm_spells_defaults[spellid][6] == "selfbuff" or vexalarm_spells_defaults[spellid][6] == "buff" or vexalarm_spells_defaults[spellid][6] == "grpbuff" then
						eventchar = "SPELL_AURA_APPLIED"
						lossEvent = true
					else
						eventchar = "SPELL_CAST_SUCCESS"
					end
					
					local alarmtype = vexalarm_Proclaims_spellcheck(spellid, caster, eventchar, frame)
					if(alarmtype ~="" and alarmtype ~="dejavue") then
						vexalarm_Proclaims_proclaim(alarmtype, spellname, spellid, caster, target, true, frame)
						if lossEvent then
							vexalarm_Testmode_lossDelayTimer(spellid, caster, target)
						end
					end
				end
			end
		end
	end
end

function vexalarm_Testmode_proclaim_loss(spellid, caster, target)
	if vexalarm.testmode then
		for frame in pairs(vexalarm_Testmode_Spells) do
			local alarmtype = vexalarm_spells_defaults[spellid][6]
			local spellname = select(1, GetSpellInfo(tonumber(spellid)))
			local eventchar = ""
			if vexalarm_spells_defaults[spellid][6][7] ~= nil then
				vexalarm_Proclaims_proclaim(alarmtype, spellname, spellid, caster, target, false, frame)
			elseif vexalarm_spells_defaults[spellid][6] == "selfbuff" or vexalarm_spells_defaults[spellid][6] == "buff" or vexalarm_spells_defaults[spellid][6] == "grpbuff" then
				local alarmtype = vexalarm_Proclaims_spellcheck(spellid, caster, "SPELL_AURA_REMOVED", frame)
				if(alarmtype ~="" and alarmtype ~="dejavue") then
					vexalarm_Proclaims_proclaim(alarmtype, spellname, spellid, caster, target, false, frame)				
				end
			end
		end
	end
end

function vexalarm_Testmode_delayTimer()
	if vexalarm.testmode then
		vexalarm_Testmode_handler(false)
		local test_aniGRP = vexalarm_event_frame:CreateAnimationGroup("vexalarm_Testmode_delayTimer")
		test_aniGRP:SetLooping("NONE")
		local test_ani = test_aniGRP:CreateAnimation("Scale")
		test_ani:SetOrder(1)
		test_ani:SetDuration(0)
		test_ani:SetScale(1,1)
		test_ani:SetEndDelay(1)
		test_aniGRP:SetScript("OnFinished", function () vexalarm_Testmode_handler(true) end)
		test_aniGRP:Play()
	end
end

function vexalarm_Testmode_lossDelayTimer(spellid, caster, target)
	if vexalarm.testmode then
		local test_aniGRP = vexalarm_event_frame:CreateAnimationGroup("vexalarm_Testmode_lossDelayTimer")
		test_aniGRP:SetLooping("NONE")
		local test_ani = test_aniGRP:CreateAnimation("Scale")
		test_ani:SetOrder(1)
		test_ani:SetDuration(0)
		test_ani:SetScale(1,1)
		test_ani:SetEndDelay(5)
		test_aniGRP:SetScript("OnFinished", function () vexalarm_Testmode_proclaim_loss(spellid, caster, target) end)
		test_aniGRP:Play()
	end
end

function vexalarm_Testmode_ani()
	if vexalarm.testmode then
		local test_aniGRP = vexalarm_event_frame:CreateAnimationGroup("vexalarm_Testmode_ani")
		test_aniGRP:SetLooping("NONE")
		local test_ani = test_aniGRP:CreateAnimation("Scale")
		test_ani:SetOrder(1)
		test_ani:SetDuration(0)
		test_ani:SetScale(1,1)
		test_ani:SetEndDelay(3)
		test_aniGRP:SetScript("OnFinished", function () vexalarm_Testmode_ani() vexalarm_Testmode_proclaim() end)
		test_aniGRP:Play()
	end
end

function vexalarm_Testmode_recolorFrameBGs()
	if vexalarm_Testmode_newBGcolors == nil then
		vexalarm_Testmode_newBGcolors = {}
	end
	for frame in pairs(vexalarm.frames) do
		if vexalarm.testmode then
			local bg = {math.random(), math.random(), math.random()}
			local border = {bg[1] + 0.5, bg[2] + 0.5, bg[3] + 0.5}
			if border[1] > 1 then border[1] = border[1] - 1 end
			if border[2] > 1 then border[2] = border[2] - 1 end
			if border[3] > 1 then border[3] = border[3] - 1 end
			vexalarm.frames[frame]:SetBackdropColor(bg[1], bg[2], bg[3], 0.5)
			vexalarm.frames[frame]:SetBackdropBorderColor(border[1], border[2], border[3], 0.5)
			vexalarm_Testmode_newBGcolors[frame] = {}
			vexalarm_Testmode_newBGcolors[frame]["bg"] = bg
			vexalarm_Testmode_newBGcolors[frame]["border"] = border
		else
			vexalarm.frames[frame]:SetBackdropColor(
				vexalarm_f_data[frame]["design"]["bg"]["color"]["r"],
				vexalarm_f_data[frame]["design"]["bg"]["color"]["g"],
				vexalarm_f_data[frame]["design"]["bg"]["color"]["b"],
				vexalarm_f_data[frame]["design"]["bg"]["color"]["a"])
				
			vexalarm.frames[frame]:SetBackdropBorderColor(
				vexalarm_f_data[frame]["design"]["border"]["color"]["r"],
				vexalarm_f_data[frame]["design"]["border"]["color"]["g"],
				vexalarm_f_data[frame]["design"]["border"]["color"]["b"],
				vexalarm_f_data[frame]["design"]["border"]["color"]["a"])
		end
	end
end

function vexalarm_Testmode_toggleFontFrames()
	if vexalarm_Testmode_FontFrames == nil then
		vexalarm_Testmode_FontFrames = {}
	end
	vexalarm_Testmode_nukeFontFrames()
	if vexalarm.testmode then
		vexalarm_Testmode_createAllFontFrames()
	end
end

function vexalarm_Testmode_nukeFontFrames()
	for frame in pairs(vexalarm_Testmode_FontFrames) do
		if vexalarm_Testmode_FontFrames[frame] ~= nil then
			for fontFrame in pairs(vexalarm_Testmode_FontFrames[frame]) do
				if vexalarm_Testmode_FontFrames[frame] ~= nil then
					vexalarm_Testmode_FontFrames[frame][fontFrame]:Hide()
					vexalarm_Testmode_FontFrames[frame][fontFrame] = nil
				end
			end
		end
	end
end

function vexalarm_Testmode_createAllFontFrames()
	for frame in pairs(vexalarm.frames) do
		vexalarm_Testmode_FontFrames[frame] = {}
		if vexalarm.frames[frame] ~= nil then
			vexalarm_Testmode_createFontFrames(frame)
		end
	end
end

function vexalarm_Testmode_createFontFrames(frame)
	if vexalarm_f_data[frame] ~= nil then
		for i=1, vexalarm_f_data[frame]["design"]["maxevents"] do
			vexalarm_Testmode_createFontFrame(frame, i)
		end
	end
end

function vexalarm_Testmode_createFontFrame(frame, position)
	local newframe = CreateFrame("Frame", nil, vexalarm.frames[frame])
	newframe:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
		
	local bg = {math.random(), math.random(), math.random()}
	local border = {bg[1] + 0.5, bg[2] + 0.5, bg[3] + 0.5}
	if border[1] > 1 then border[1] = border[1] - 1 end
	if border[2] > 1 then border[2] = border[2] - 1 end
	if border[3] > 1 then border[3] = border[3] - 1 end
	newframe:SetBackdropColor(bg[1], bg[2], bg[3], 0.5)
	newframe:SetBackdropBorderColor(border[1], border[2], border[3], 0.5)
	newframe:SetWidth(vexalarm_f_data[frame]["design"]["size"]["width"]-(vexalarm_f_data[frame]["design"]["position"]["alarm"]["x"]*2))
	newframe:SetHeight(vexalarm_f_data[frame]["design"]["text"]["size"])
	newframe:ClearAllPoints()
	if vexalarm_f_data[frame]["design"]["scrolldown"] then
		newframe:SetPoint("BOTTOMLEFT", vexalarm.frames[frame], "BOTTOMLEFT",
									vexalarm_f_data[frame]["design"]["position"]["alarm"]["x"],
									(vexalarm_f_data[frame]["design"]["position"]["alarm"]["spacing"]*position)-vexalarm_f_data[frame]["design"]["position"]["alarm"]["y"])

	else
		newframe:SetPoint("TOPLEFT", vexalarm.frames[frame], "TOPLEFT",
									vexalarm_f_data[frame]["design"]["position"]["alarm"]["x"],
									(-vexalarm_f_data[frame]["design"]["position"]["alarm"]["spacing"]*position)+vexalarm_f_data[frame]["design"]["position"]["alarm"]["y"])
	end		
	newframe:Show()
	
	vexalarm_Testmode_FontFrames[frame][tostring(position)] = newframe
end















