function vexalarm.panel_frameContent()
	local temp = {
		type = "group",
		args = {
			grptestmode = {
				name = "Testmode",
				order=1, type ="group", dialogInline = true,
				args = {
					testmode = {
						name = "Activate",
						order=1, type = "toggle", width="full",
						set = function(info,val) vexalarm_Testmode_handler(val) end,
						get = function() return vexalarm.testmode end,
						},
					testmodeinfo = {name = "- Simulates Event outputs. The spell/spell-profile adjustments for the frames are still active.\n- Frames become movable\n- Frames and Outputpositions become recolored", type = "description", order=2},
					},
				},
			frame_space_testmode = {name ="\n", type = "description", order=2},
			}
		}
	local framelist = {}
	for key in pairs(vexalarm_f_data) do
		framelist[#framelist+1] = key
	end
	table.sort(framelist, function (a,b) return a<b end)
	
	local counter = 0
	for i,key in pairs(framelist) do
		counter = counter +1
		local framegrp = {
			type = "group",
			name = "Frame: "..key, dialogInline = true,
			order = counter*50,
			args = {		
				useprofile = {
					name = "Use a spell-profile for spellchecks, instead of the current settings",
					order=1, type = "toggle", width="full",
					set = function(self,val) vexalarm_f_data[key]["spelldata"]["useprofile"] = val vexalarm_initialize(true) vexalarm_Testmode_delayTimer() end,
					get = function() return vexalarm_f_data[key]["spelldata"]["useprofile"] end,
					},
				spellprofile = {
					name = "Existings spell-profiles",
					order=2, type = "select", style = "dropdown", width="double",
					values = vexalarm_optionTab_SpellProfiles_getList(false, true),
					disabled = not(vexalarm_f_data[key]["spelldata"]["useprofile"]),
					set = function(self,sp) vexalarm_f_data[key]["spelldata"]["spellprofile"] = sp vexalarm_initialize(true) vexalarm_Testmode_delayTimer() end,
					get = function() return vexalarm_f_data[key]["spelldata"]["spellprofile"] end,
					},
				},
			}
		temp.args[key] = framegrp
		temp.args[key.."space"] = {name =" ", type = "description", order=counter*5+1}
	end
	
	if counter == 0 then
		local temp = {
			type = "group",
			args = {
				info = {name = "No frame created", type = "description", order=15},
				}
			}
	end
	
	return temp
end
