vexalarm_optionTab_FrameSettings_currentframe = ""

vexalarm_optionTab_FrameSettings_name = ""
vexalarm_optionTab_FrameSettings_newname = ""

vexalarm_optionTab_FrameSettings_statusMsg = {
	["create"] = " ",
	["rename"] = " ",
	["delete"] = " "}

vexalarm_optionTab_FrameSettings_openTab = {
	["manager"] = false,
	["content"] = false,
	["design"] = false,
	["text"] = false,
	["sounds"] = false,
	["show"] = false,
	}

function vexalarm_optionTab_FrameSettings_feedback(category, text, error)
	for key in pairs(vexalarm_optionTab_FrameSettings_statusMsg) do
		vexalarm_optionTab_FrameSettings_statusMsg[key] = " "
	end
	if error then
		text = "|CFFC41F3B"..text.."|r"
	else
		text = "|CFF00FF00"..text.."|r"
	end
	if vexalarm_optionTab_FrameSettings_statusMsg[category] ~= nil then
		vexalarm_optionTab_FrameSettings_statusMsg[category] = text
	end
end

function vexalarm_optionTab_FrameSettings_toggleTab(tab)
	if vexalarm_optionTab_FrameSettings_openTab[tab] ~= nil then
		vexalarm_optionTab_FrameSettings_closeAllTabs()
		vexalarm_optionTab_FrameSettings_openTab[tab] = true
	end
end

function vexalarm_optionTab_FrameSettings_closeAllTabs()
	for key in pairs(vexalarm_optionTab_FrameSettings_openTab) do
		vexalarm_optionTab_FrameSettings_openTab[key] = false
	end
end

function vexalarm_optionTab_FrameSettings_setCurrentFrame()
	local changed = false
	local counter = 0
	
	for key in pairs(vexalarm.frames) do
		counter = counter + 1
	end
	
	if counter == 1 then
		for key in pairs(vexalarm.frames) do
			if not(changed) then
				vexalarm_optionTab_FrameSettings_currentframe = key
				vexalarm_optionTab_FrameSettings_newname = key
				changed = true
			end
		end
	end
end

function vexalarm_optionTab_FrameSettings_getList(returntimer)
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexalarm.frames) do
		returnvalue[key]=key
		timer = timer + 1
	end
	
	if timer == 0 then
		returnvalue[""] = "No frame created"
	end
	
	if returntimer then
		return timer
	else
		return returnvalue
	end
end

function vexalarm_optionTab_FrameSettings_create()
	local key = vexalarm_optionTab_FrameSettings_name
	
	if vexalarm_optionTab_General_checkName(key) then
		vexalarm_f_data[key] = vexalarm_CopyTable(vexalarm_frame_defaults["Mainframe"])
		vexalarm_optionTab_FrameSettings_name = ""
		vexalarm_optionTab_FrameSettings_feedback("create", "Frame successfully created", false)
	else
		vexalarm_optionTab_FrameSettings_feedback("create", "Couldn't create frame. Name is invalid.", true)
	end
	vexalarm_optionTab_FrameSettings_setCurrentFrame()
end

function vexalarm_optionTab_FrameSettings_clone()
	local key = vexalarm_optionTab_FrameSettings_name
	local clone = vexalarm_optionTab_FrameSettings_currentframe
	
	if vexalarm_optionTab_General_checkName(key) and vexalarm_f_data[clone] ~= nil then
		vexalarm_f_data[key] = vexalarm_CopyTable(vexalarm_f_data[clone])
		vexalarm_optionTab_FrameSettings_name = ""
		vexalarm_optionTab_FrameSettings_feedback("create", "Frame successfully created (Clone of '"..clone.."'", false)
	elseif not(vexalarm_optionTab_General_checkName(key)) then
		vexalarm_optionTab_FrameSettings_feedback("create", "Couldn't clone frame. Name is invalid.", true)
	elseif vexalarm_f_data[clone] == nil then
		vexalarm_optionTab_FrameSettings_feedback("create", "Couldn't clone from frame. Target frame doesn't exist.", true)
	end
end

function vexalarm_optionTab_FrameSettings_rename()
	local key = vexalarm_optionTab_FrameSettings_currentframe
	local name = vexalarm_optionTab_FrameSettings_newname
	
	if vexalarm_optionTab_General_checkName(name) and vexalarm_f_data[key]~=nil then
		vexalarm_f_data[name] = vexalarm_CopyTable(vexalarm_f_data[key])
		vexalarm_f_data[key] = nil
		vexalarm_optionTab_FrameSettings_newname = name
		vexalarm_optionTab_FrameSettings_currentframe = name
		
		vexalarm_optionTab_FrameSettings_feedback("rename", "Frame successfully renamed", false)
	elseif not(vexalarm_optionTab_General_checkName(name)) then
		vexalarm_optionTab_FrameSettings_feedback("rename", "Couldn't rename frame. New name is invalid.", true)
	elseif vexalarm_f_data[key] == nil then
		vexalarm_optionTab_FrameSettings_feedback("rename", "Couldn't rename frame. Frame doesn't exist.", true)
	end
end

function vexalarm_optionTab_FrameSettings_frameDelete()
	local key = vexalarm_optionTab_FrameSettings_currentframe	
	if vexalarm_optionTab_General_checkName(key) and vexalarm_f_data[key]~=nil then
		vexalarm_f_data[key] = nil
		vexalarm_optionTab_FrameSettings_currentframe = ""
		vexalarm_optionTab_FrameSettings_newname = ""
		vexalarm_optionTab_FrameSettings_feedback("delete", "Frame successfully deleted", false)
	elseif not(vexalarm_optionTab_General_checkName(name)) then
		vexalarm_optionTab_FrameSettings_feedback("delete", "Couldn't delete frame. Name is invalid.", true)
	elseif vexalarm_f_data[key] == nil then
		vexalarm_optionTab_FrameSettings_feedback("delete", "Couldn't delete frame. Frame doesn't exist.", true)
	end
	vexalarm_optionTab_FrameSettings_setCurrentFrame()
end

function vexalarm_optionTab_FrameSettings_getDisabled(list, val)
	if list[val] == nil or val == "" then
		return true
	else
		return false
	end
end

function vexalarm_optionTab_FrameSettings_returnOutPuts(data, arg)
	if vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe] == nil then
		if arg == "r" or arg == "g" or arg == "b" or arg == "a" then
			return 0
		else
			return nil
		end
	else
		local framedata = vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]
		if 		data == "font" 				then return framedata["design"]["text"]["font"]
		elseif 	data == "size"				then return framedata["design"]["text"]["size"]
		elseif 	data == "align"				then return framedata["design"]["text"]["align"]
		elseif 	data == "outline"			then return framedata["design"]["text"]["outline"]
		elseif 	data == "alarmx"			then return framedata["design"]["position"]["alarm"]["x"]
		elseif 	data == "alarmy"			then return framedata["design"]["position"]["alarm"]["y"]
		elseif 	data == "alarms"			then return framedata["design"]["position"]["alarm"]["spacing"]
		elseif 	data == "maxevents"			then return framedata["design"]["maxevents"]
		elseif 	data == "scrolldown"		then return framedata["design"]["scrolldown"]
		
		
		elseif 	data == "status_sca"		then return framedata["design"]["text"]["color"]["active"][arg]
		elseif 	data == "status_sci"		then return framedata["design"]["text"]["color"]["inactive"][arg]
		
		elseif 	data == "colorg"			then return framedata["colors"]["active"][arg]
		elseif 	data == "colorf"			then return framedata["colors"]["inactive"][arg]
		elseif 	data == "caster_sc"			then return framedata["colors"]["caster_sc"][arg]
		elseif 	data == "target_sc"			then return framedata["colors"]["target_sc"][arg]
		elseif 	data == "spell_sc"			then return framedata["colors"]["spell_sc"][arg]
		
		
		elseif 	data == "allowvanish"		then return framedata["timedata"]["allowvanish"]
		elseif 	data == "tdshow"			then return framedata["timedata"]["show"]
		elseif 	data == "tdvanish"			then return framedata["timedata"]["vanish"]
		elseif 	data == "allowscrolling"	then return not(framedata["design"]["allowscrolling"])
		else 
			if arg == "r" or arg == "g" or arg == "b" or arg == "a" then
				return 0
			else
				return nil
			end
		end
	end
end

function vexalarm_optionTab_FrameSettings_returnDesign(data, arg)
	if vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe] == nil then
		if arg == "r" or arg == "g" or arg == "b" or arg == "a" then
			return 0
		else
			return nil
		end
	else
		local framedata = vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]
		if 		data == "width" 	then return framedata["design"]["size"]["width"]
		elseif 	data == "height"	then return framedata["design"]["size"]["height"]
		elseif 	data == "x"			then return framedata["design"]["position"]["bg"]["x"]
		elseif 	data == "y"			then return framedata["design"]["position"]["bg"]["y"]
		elseif 	data == "anchor1"	then return framedata["design"]["position"]["bg"]["anchor"]
		elseif 	data == "anchor2"	then return framedata["design"]["position"]["bg"]["frameanchor"]
		elseif 	data == "bgtexture"	then return framedata["design"]["bg"]["texture"]
		elseif 	data == "bgcolor"	then return framedata["design"]["bg"]["color"][arg]
		elseif 	data == "bordert"	then return framedata["design"]["border"]["texture"]
		elseif 	data == "borders"	then return framedata["design"]["border"]["size"]
		elseif 	data == "borderc"	then return framedata["design"]["border"]["color"][arg]
		elseif 	data == "height"	then return framedata["design"]["size"]["height"]
		else 
			if arg == "r" or arg == "g" or arg == "b" or arg == "a" then
				return 0
			else
				return nil
			end
		end
	end
end

function vexalarm_optionTab_FrameSettings_returnSounds(data)
	if vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe] == nil then
		return nil
	else
		local framedata = vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]
		if 		data == "allow" 	then return framedata["sounds"]["allow"] 
		elseif 	data == "file1"		then return framedata["sounds"]["active"]["file"]
		elseif 	data == "file2"		then return framedata["sounds"]["inactive"]["file"]
		elseif 	data == "file3"		then return framedata["sounds"]["cast"]["file"]
		elseif 	data == "channel1"	then return framedata["sounds"]["active"]["channel"]
		elseif 	data == "channel2"	then return framedata["sounds"]["inactive"]["channel"]
		elseif 	data == "channel3"	then return framedata["sounds"]["cast"]["channel"]
		else 
			return nil
		end
	end
end

function vexalarm_optionTab_FrameSettings_returnShow(data)
	if vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe] == nil then
		return nil
	else
		local framedata = vexalarm_f_data[vexalarm_optionTab_FrameSettings_currentframe]
		if 		data == "showonlyinfight" 		then return framedata["show"]["showonlyinfight"] 
		elseif 	data == "showgrponly"			then return framedata["show"]["showgrponly"]
		elseif 	data == "showFrameonlyinfight"	then return framedata["show"]["showFrameonlyinfight"]
		elseif 	data == "myspells"				then return framedata["show"]["myspells"]
		else 
			return nil
		end
	end
end