vexalarm_optionTab_Profiles_profile = ""
vexalarm_optionTab_Profiles_new = ""
vexalarm_optionTab_Profiles_newname = ""

vexalarm_optionTab_Profiles_statusMsg = {
	["save"] = " ",
	["rename"] = " ",
	["load"] = " ",
	["delete"] = " "}

function vexalarm_optionTab_Profiles_feedback(category, text, isError)
	for key in pairs(vexalarm_optionTab_Profiles_statusMsg) do
		vexalarm_optionTab_Profiles_statusMsg[key] = " "
	end
	if isError then
		text = "|CFFC41F3B"..text.."|r"
	else
		text = "|CFF00FF00"..text.."|r"
	end
	
	if vexalarm_optionTab_Profiles_statusMsg[category] ~= nil then
		vexalarm_optionTab_Profiles_statusMsg[category] = text
	end
end

function vexalarm_optionTab_Profiles_save()
	local key = vexalarm_optionTab_Profiles_new
	if vexalarm_optionTab_General_checkName(key) then
		if vexalarm_p[key] == nil then vexalarm_p[key] = {} end
		
		-- DATA
		if vexalarm_p[key]["data"] == nil then vexalarm_p[key]["data"] = {} end
		vexalarm_p[key]["data"] = vexalarm_CopyTable(vexalarm_data)
		
		-- F DATA
		if vexalarm_p[key]["f_data"] == nil then vexalarm_p[key]["f_data"] = {} end
		vexalarm_p[key]["f_data"] = vexalarm_CopyTable(vexalarm_f_data)
		
		-- SP
		if vexalarm_p[key]["sp"] == nil then vexalarm_p[key]["sp"] = {} end
		vexalarm_p[key]["sp"] = vexalarm_CopyTable(vexalarm_sp)
		
		-- S
		if vexalarm_p[key]["s"] == nil then vexalarm_p[key]["s"] = {} end
		vexalarm_p[key]["s"] = vexalarm_CopyTable(vexalarm_s)
		
		vexalarm_optionTab_Profiles_new = ""
		
		vexalarm_optionTab_Profiles_feedback("save", "Profile saved successfully", false)
	else
		vexalarm_optionTab_Profiles_feedback("save", "Couldn't save profil. Name is invalid.", true)
	end
end


function vexalarm_optionTab_Profiles_getList(default)
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexalarm_p) do
		if key == vexalarm_default_data["profile"] and default then
			returnvalue[key]=key.." (Default Profile)"
		else
			returnvalue[key]=key
		end
		timer = timer + 1
	end
	
	if timer == 0 then
		returnvalue[""] = "No saved profile found"
	end
	
	return returnvalue
end

function vexalarm_optionTab_Profiles_delete()
	local key = vexalarm_optionTab_Profiles_profile
	
	if vexalarm_optionTab_General_checkName(key) then
		vexalarm_p[key] = nil
		vexalarm_optionTab_Profiles_newname = ""
		vexalarm_optionTab_Profiles_profile = ""
		
		vexalarm_optionTab_Profiles_feedback("delete", "Profile deleted successfully", false)
	else
		vexalarm_optionTab_Profiles_feedback("delete", "Couldn't delete profile. Profilename is not valid.", true)
	end
end

function vexalarm_optionTab_Profiles_rename()
	local key = vexalarm_optionTab_Profiles_profile
	local name = vexalarm_optionTab_Profiles_newname
	
	if vexalarm_optionTab_General_checkName(name) and vexalarm_p[key]~=nil then
		if key ~= name then
			vexalarm_p[name] = vexalarm_CopyTable(vexalarm_p[key])
			vexalarm_p[key] = nil
			vexalarm_optionTab_Profiles_newname = name
			vexalarm_optionTab_Profiles_profile = name
			
			vexalarm_optionTab_Profiles_feedback("rename", "Profile renamed successfully", false)
		else
			vexalarm_optionTab_Profiles_feedback("rename", "Couldn't rename profile. Reason: The new name and the old name are the same.", true)
		end
	elseif not(vexalarm_optionTab_General_checkName(name)) then
		vexalarm_optionTab_Profiles_feedback("rename", "Couldn't rename profile. New profilename is not valid.", true)
	elseif vexalarm_p[key]==nil then
		vexalarm_optionTab_Profiles_feedback("rename", "Couldn't rename profile. Old profile wasn't found.", true)
	end
end

function vexalarm_optionTab_Profiles_load(fragment, noreload, all)
	local key = vexalarm_optionTab_Profiles_profile
	if vexalarm_optionTab_General_checkName(key) then
		if vexalarm_p[key] ~= nil then 
			if fragment == "all" then
				vexalarm_optionTab_Profiles_load("data", noreload, true)
				vexalarm_optionTab_Profiles_load("f_data", noreload, true)
				vexalarm_optionTab_Profiles_load("spelldata", noreload, true)
			elseif fragment == "data" then
				vexalarm_data = vexalarm_CopyTable(vexalarm_p[key]["data"])
			elseif fragment == "f_data" then
				vexalarm_f_data = vexalarm_CopyTable(vexalarm_p[key]["f_data"])
			elseif fragment == "spelldata" then
				for k,v in pairs (vexalarm_CopyTable(vexalarm_p[key]["sp"])) do
					vexalarm_sp[k] = vexalarm_CopyTable(v)
				end
				vexalarm_s = vexalarm_CopyTable(vexalarm_p[key]["s"])
			end
			if not(noreload) then
				vexalarm_initialize(true)
			end
		end
		
		local load_string = ""
		if fragment == "all" then
			load_string = "Complete profile"
		elseif not(all) and fragment == "spelldata" then
			load_string = "Spelldata"
		elseif not(all) and fragment == "data" then
			load_string = "Settings"
		elseif not(all) and fragment == "f_data" then
			load_string = "Frames"
		end
		vexalarm_optionTab_Profiles_feedback("load", load_string.." loaded successfully", false)
	else
		vexalarm_optionTab_Profiles_feedback("load", "Couldn't load profile. Profile name is invalid.", true)
	end
end