
vexalarm_optionTab_SpellProfiles_profile = ""
vexalarm_optionTab_SpellProfiles_name = ""
vexalarm_optionTab_SpellProfiles_newname = ""
vexalarm_optionTab_SpellProfiles_target = ""


vexalarm_optionTab_SpellProfiles_statusMsg = {
	["save"] = " ",
	["rename"] = " ",
	["load"] = " ",
	["send"] = " ",
	["saveRe"] = " "}

vexalarm_optionTab_SpellProfiles_RecSP = ""
vexalarm_optionTab_SpellProfiles_RecSP_newname = ""

function vexalarm_optionTab_SpellProfiles_feedback(category, text, error)
	for key in pairs(vexalarm_optionTab_SpellProfiles_statusMsg) do
		vexalarm_optionTab_SpellProfiles_statusMsg[key] = " "
	end
	if error then
		text = "|CFFC41F3B"..text.."|r"
	else
		text = "|CFF00FF00"..text.."|r"
	end
	if vexalarm_optionTab_SpellProfiles_statusMsg[category] ~= nil then
		vexalarm_optionTab_SpellProfiles_statusMsg[category] = text
	end
end

function vexalarm_optionTab_SpellProfiles_getList(addCurrent, showSet)
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexalarm_sp) do
		if showSet then
			local framesUsed = ""
			for frame,val in pairs (vexalarm_f_data) do
				if key == val["spelldata"]["spellprofile"] then
					if framesUsed ~= "" then
						framesUsed = framesUsed..", "
					end
					framesUsed = framesUsed..frame
				end
			end
			if vexalarm_data["rw"]["spelldata"]["spellprofile"] == key then
				if framesUsed ~= "" then
					framesUsed = framesUsed..", "
				end
				framesUsed = framesUsed.."RW"
			end
			if framesUsed == "" then
				returnvalue[key]=key
			else
				returnvalue[key]=key.." ("..framesUsed..")"
			end
		else
			returnvalue[key]=key
		end
		timer = timer + 1
	end
	if addCurrent then
		returnvalue[""] = "Current settings"
	elseif timer == 0 then
		returnvalue[""] = "No saved profile found"
	end
	
	return returnvalue
end

function vexalarm_optionTab_SpellProfiles_save()
	local key = vexalarm_optionTab_SpellProfiles_name
	
	if vexalarm_optionTab_General_checkName(key) then
		vexalarm_sp[key] = vexalarm_CopyTable(vexalarm_s)
		vexalarm_optionTab_SpellProfiles_name = ""
		
		vexalarm_optionTab_SpellProfiles_feedback("save", "Spell-profile saved successfully", false)
	end
end

function vexalarm_optionTab_SpellProfiles_rename()
	local key = vexalarm_optionTab_SpellProfiles_profile
	local name = vexalarm_optionTab_SpellProfiles_newname
	
	if vexalarm_optionTab_General_checkName(name) and vexalarm_sp[key]~=nil then
		if name ~= key then
			vexalarm_sp[name] = vexalarm_CopyTable(vexalarm_sp[key])
			vexalarm_sp[key] = nil
			vexalarm_optionTab_SpellProfiles_newname = name
			vexalarm_optionTab_SpellProfiles_profile = name
			
			vexalarm_optionTab_SpellProfiles_feedback("rename", "Spell-profile renamed successfully", false)
		else
			vexalarm_optionTab_SpellProfiles_feedback("rename", "Couldn't rename profile. Reason: The new name and the old name are the same.", true)
		end
	end
end

function vexalarm_optionTab_SpellProfiles_delete()
	local key = vexalarm_optionTab_SpellProfiles_profile
	
	if vexalarm_optionTab_General_checkName(key) then
		vexalarm_sp[key] = nil
		vexalarm_optionTab_SpellProfiles_profile = ""
		vexalarm_optionTab_SpellProfiles_newname = ""
			
		vexalarm_optionTab_SpellProfiles_feedback("load", "Spell-profile deleted successfully", false)
	end
end

function vexalarm_optionTab_SpellProfiles_load(key, slashcmd)
	if key == nil then
		key = vexalarm_optionTab_SpellProfiles_profile
	end
	if vexalarm_optionTab_General_checkName(key) then
		if vexalarm_sp[key] == nil then
			if slashcmd then
				print("|CFFFF7D0AVex Alarm|r - ERROR - Couldn't load spell-profile. Reason: Spell-profile '"..key.."' doesn't exist.")
			else
			vexalarm_optionTab_SpellProfiles_feedback("load", "Couldn't load spell-profile. Reason: Spell-profile '"..key.."' doesn't exist.", true)
			end
		else
			vexalarm_s = vexalarm_CopyTable(vexalarm_sp[key])
			vexalarm_Loader_LoadParamters(false)
			if slashcmd then
				print("|CFFFF7D0AVex Alarm|r - Spell-profile '"..key.."' has been loaded succesfully")
			else
				vexalarm_optionTab_SpellProfiles_feedback("load", "Spell-profile '"..key.."' has been loaded succesfully", false)
			end
		end
	end
end

function vexalarm_optionTab_SpellProfiles_recSPGetList()
	local returnvalue = {}
	local empty = true
	for key,val in pairs(vexalarm.incomeSpellProfiles) do
		returnvalue[key] = val["timestamp"].." "..val["name"]
		empty = false
	end
	if empty then
		returnvalue[""] = "No received profile found"
	end
	return returnvalue
end

function vexalarm_optionTab_SpellProfiles_recSPSave()
	local key = vexalarm_optionTab_SpellProfiles_RecSP
	local name = vexalarm_optionTab_SpellProfiles_RecSP_newname
	if vexalarm_optionTab_General_checkName(name) then
		vexalarm_sp[name] = vexalarm_CopyTable(vexalarm.incomeSpellProfiles[key]["data"])
		vexalarm.incomeSpellProfiles[key] = nil
		vexalarm_optionTab_SpellProfiles_RecSP = ""
		vexalarm_optionTab_SpellProfiles_RecSP_newname = ""
		
		vexalarm_optionTab_SpellProfiles_feedback("saveRe", "Received spell-profile saved successfully", false)
	end
end


function string:vexalarm_Msgs_split(splitter)
	local returnvalue = {}
	for part in string.gmatch(self, ".-"..splitter) do
		part = string.gsub(part, splitter, "")
		returnvalue[#returnvalue+1] = part
	end
	return returnvalue
end

function vexalarm_Msgs_recSP_RE(msg, sender)
	if vexalarm.sentMsgs[msg] == sender then
		vexalarm.sentMsgs[msg] = nil
		vexalarm.SendSuccess = true
		
		print("|CFFFF7D0AVex Alarm|r - |CFF00FF00Spellprofile has been successfully sent|r")
	end
end


function vexalarm_Msgs_successTimer()
	vexalarm_Testmode_handler(false)
	local test_aniGRP = vexalarm_event_frame:CreateAnimationGroup("vexalarm_Msgs_successTimer")
	test_aniGRP:SetLooping("NONE")
	local test_ani = test_aniGRP:CreateAnimation("Scale")
	test_ani:SetOrder(1)
	test_ani:SetDuration(0)
	test_ani:SetScale(1,1)
	test_ani:SetEndDelay(5)
	test_aniGRP:SetScript("OnFinished",
		function ()
			if not(vexalarm.SendSuccess) then
				print("|CFFFF7D0AVex Alarm|r - |CFFC41F3BSpellprofile couldn't be delivered|r")
			end
		end)
	test_aniGRP:Play()
end


function vexalarm_Msgs_recSP(msg, sender)
	local content = msg:vexalarm_Msgs_split(";")	
			
	local timestamp = content[1]
	local name = content[2]
	local part = tonumber(content[3])
	local quantity = tonumber(content[4])
	local package = content[5]
	
	if vexalarm.incomeMsgs[timestamp] == nil then
		vexalarm.incomeMsgs[timestamp] = {}
	end
	
	if vexalarm.incomeMsgs[timestamp]["parts"] == nil then
		vexalarm.incomeMsgs[timestamp]["parts"] = {}
	end
	
	if vexalarm.incomeMsgs[timestamp]["received"] == nil then
		vexalarm.incomeMsgs[timestamp]["received"] = {}
		for i=1, quantity do
			vexalarm.incomeMsgs[timestamp]["received"][i] = false
		end
	end
	
	vexalarm.incomeMsgs[timestamp]["received"][part] = true
	vexalarm.incomeMsgs[timestamp]["quantity"] = quantity
	vexalarm.incomeMsgs[timestamp]["parts"][part] = package
	
	
	local complete = true
	for i,v in ipairs(vexalarm.incomeMsgs[timestamp]["received"]) do
		if not(v) then
			complete = false
		end
	end
	
	if complete then
		vexalarm.incomeSpellProfiles[timestamp] = {}
		
		local text = ""
		for i,v in ipairs(vexalarm.incomeMsgs[timestamp]["parts"]) do
			text = text..v
		end
	
		local data = {}
		local spells = text:vexalarm_Msgs_split(",")
		local timer = 0
		for i, v in ipairs(spells) do
			local spelldata = v:vexalarm_Msgs_split("=")
			
			data[spelldata[1]] = {}
			
			for j=1,4 do
				data[spelldata[1]][j] = string.sub(spelldata[2], j, j) == "1"
			end
		end
				
		vexalarm.incomeSpellProfiles[timestamp]["data"] = data
						
		vexalarm.incomeSpellProfiles[timestamp]["timestamp"] = date("%d/%m/%y %H:%M")
		vexalarm.incomeSpellProfiles[timestamp]["name"] = name	
		vexalarm_initialize(true)
		print("|CFFFF7D0AVex Alarm|r - Spellprofile '"..name.."' from '"..sender.."' has been received")
		SendAddonMessage("VEXALARM_SP_RE", timestamp , "whisper" , sender)	
	end
end

function vexalarm_Msgs_send()
	local spellprofile = vexalarm_optionTab_SpellProfiles_profile
	local user = vexalarm_optionTab_SpellProfiles_target
	local packages = {}
	local timer = 0
	local currentpackage = 1
	
	vexalarm.SendSuccess = false
	
	if vexalarm_sp[spellprofile]~= nil and user ~= "" then
		for key in pairs(vexalarm_spells_defaults) do
			if timer>=15 then
				currentpackage = currentpackage + 1
				timer = 0
			end
			timer = timer + 1
			
			if packages[currentpackage] == nil then
				packages[currentpackage] = ""
			end
			
			local text = key.."="
			for i=1,4 do
				local boolean = 0
				if vexalarm_sp[spellprofile][key] ~= nil then
					if vexalarm_sp[spellprofile][key][i] ~= nil then
						if vexalarm_sp[spellprofile][key][i] then
							boolean = 1
						end
					end
				end
				text = text..boolean
			end
			text = text.."="
			
			packages[currentpackage] = packages[currentpackage]..text..","
		end
	end
	local msgcount = #packages
	if msgcount > 0 then
		local timestamp = GetTime()
		for i=1,msgcount do
			local text = timestamp..";"..spellprofile..";"..i..";"..msgcount..";"..packages[i]..";"
			SendAddonMessage("VEXALARM_SP", text , "whisper" , user)
		end
		vexalarm.sentMsgs[tostring(timestamp)] = user
		vexalarm_Msgs_successTimer()
		print("|CFFFF7D0AVex Alarm|r - |CFF00FF00Spellprofile '"..spellprofile.."' is on its way to '"..user.."'|r")
	end
end