vexalarm_optionTab_Spells_eventType = 1
vexalarm_optionTab_Spells_class = 0
vexalarm_optionTab_Spells_SP = ""
vexalarm_optionTab_Spells_name = ""

vexalarm_optionTab_Spells_statusMsg = " "

function vexalarm_optionTab_Spells_getAlphSpellist(spelltype, class)
	local returnvalue = {}
	-- get all spells of the category
	local place = 1
	for key, val in pairs(vexalarm_spells_defaults) do	
		if val[6] == spelltype and val[5] == class then
			local spellname = string.lower(select(1, GetSpellInfo(tonumber(key))))
			if vexalarm_optionTab_Spells_name == "" or string.find(spellname,string.lower(vexalarm_optionTab_Spells_name))~= nil then
				if select(1, GetSpellInfo(tonumber(key))) ~= nil then
					returnvalue[place] = {select(1, GetSpellInfo(tonumber(key))), key}
					place = place + 1
				else
					vexalarm.wrongspells[key] = key
				end
			end
		end
	end
	table.sort(returnvalue, function(a,b) return a[1]<b[1] end)
	return returnvalue
end

function vexalarm_optionTab_Spells_GetClassFilter()
	if vexalarm_optionTab_Spells_class == 12 then
		return 1
	elseif vexalarm_optionTab_Spells_class ~= 0 then
		return vexalarm_optionTab_Spells_class +1
	else
		return vexalarm_optionTab_Spells_class
	end
end

function vexalarm_optionTab_Spells_setFilter(category, val)
	vexalarm_optionTab_Spells_statusMsg = " "
	if category == "class" then
		if val == 1 then
			val = 12
		elseif val~= 0 then
			val = val-1
		end
		vexalarm_optionTab_Spells_class = val
	elseif category  == "spelltype" then
		vexalarm_optionTab_Spells_eventType = val
	end
end

function vexalarm_optionTab_Spells_getButton(rolestring, enable, role, rank)
	local returnvalue = {
		name = enable[1].." "..rolestring,
		func = function(info,val) vexalarm_optionTab_Spells_toggleSpells(enable[3], role) end,
		order=rank, type = "execute",}
	if role~=4 then returnvalue.width="half" end
	return returnvalue
end

function vexalarm_optionTab_Spells_getToolTipButton(spellid, rank, class, classstring, spelltype)
	local returnvalue = {
		name = "tooltip",
		func = function(info,val) vexalarm_SpellWindow_toggle(false, tonumber(spellid), class, classstring, spelltype) end,
		order=rank, type = "execute",
		width="half"}
	return returnvalue
end

function vexalarm_optionTab_Spells_getDescription(key, rank)
	local returnvalue = {fontSize="large", image = select(3, GetSpellInfo(tonumber(key))), type="description", order=rank}
	local spellname = vexalarm_Colorize_class(select(1, GetSpellInfo(tonumber(key))), key, "spell")		--.." (ID:"..key..")"
	local advanced_tooltip = {
		["86669"] = "(holy)",
		["86698"] = "(retri)",
		["86659"] = "(prot) (broken)",
		["77764"] = "(cat form)",
		["77761"] = "(bear form)",
		["106898"] = "(no form)",
		["117679"] = "(Tree of Life)",
		}
	if advanced_tooltip[key] ~= nil then
		returnvalue.name = spellname.." "..advanced_tooltip[key]
	else
		returnvalue.name = spellname
	end
	
	return returnvalue
end

function vexalarm_optionTab_Spells_getToggle(rolestring, key, role, rank)	
	local returnvalue = {
		name = rolestring,
		order=rank, type = "toggle",
		desc = "Output when the caster's role i "..rolestring,
		set = function(info,val) vexalarm_optionTab_Spells_setSpell(key, role, val) end,
		get = function() return vexalarm_optionTab_Spells_getSpell(key, role) end
		}
	
	if role ~= 4 then returnvalue.width="half" end
	return returnvalue
end
function vexalarm_optionTab_Spells_setSpell(spell, role, newval)
	if vexalarm_optionTab_Spells_SP == "" then
		if vexalarm_s[spell] == nil then
			vexalarm_s[spell]={}
		end
		vexalarm_s[spell][role]=newval
	elseif vexalarm_sp[vexalarm_optionTab_Spells_SP] ~= nil then
		if vexalarm_sp[vexalarm_optionTab_Spells_SP][spell] == nil then
			vexalarm_sp[vexalarm_optionTab_Spells_SP][spell]={}
		end
		vexalarm_sp[vexalarm_optionTab_Spells_SP][spell][role]=newval
	end
	vexalarm_Testmode_delayTimer()
end

function vexalarm_optionTab_Spells_getSpell(spell, role)
	if vexalarm_optionTab_Spells_SP == "" then
		if vexalarm_s[spell]==nil then
			return false
		else
			return vexalarm_s[spell][role]
		end
	elseif vexalarm_sp[vexalarm_optionTab_Spells_SP] ~= nil then
		if vexalarm_sp[vexalarm_optionTab_Spells_SP][spell] == nil then
			return false
		else
			return vexalarm_sp[vexalarm_optionTab_Spells_SP][spell][role]
		end
	else
		return false
	end
end

function vexalarm_optionTab_Spells_toggleSpells(newval, role)
	local spelltypes = {"buff", "selfbuff", "grpbuff", "instant", "instantself"}
	local classnames = {"DEATHKNIGHT", "DRUID", "HUNTER", "MAGE", "MONK", "PALADIN", "PRIEST", "ROGUE", "SHAMAN", "WARLOCK", "WARRIOR", ""}
	local class = classnames[vexalarm_optionTab_Spells_class]
	local spelltype = spelltypes[vexalarm_optionTab_Spells_eventType]
	local name = vexalarm_optionTab_Spells_name	
	
	for key,val in pairs(vexalarm_spells_defaults) do
		if spelltype == nil or val[6] == spelltype then
			if class == nil or val[5] == class then			
				local spellname = string.lower(select(1, GetSpellInfo(tonumber(key))))		
				if name == "" or string.find(spellname,string.lower(name))~= nil then 
					if vexalarm_optionTab_Spells_SP == "" then
						if vexalarm_s[key] == nil then
							vexalarm_s[key] = vexalarm_CopyTable(vexalarm_spells_defaults[key])
						end
						if role == nil then
							for i=1,4 do
								vexalarm_s[key][i] = newval
							end
						else
							vexalarm_s[key][role] = newval
						end
					elseif vexalarm_sp[vexalarm_optionTab_Spells_SP] ~= nil then
						if vexalarm_sp[vexalarm_optionTab_Spells_SP][key] == nil then
							vexalarm_sp[vexalarm_optionTab_Spells_SP][key] = vexalarm_CopyTable(vexalarm_spells_defaults[key])
						end
						if role == nil then
							for i=1,4 do
								vexalarm_sp[vexalarm_optionTab_Spells_SP][key][i] = newval
							end
						else
							vexalarm_sp[vexalarm_optionTab_Spells_SP][key][role] = newval
						end
					end
				end
			end
		end
	end
	vexalarm_Testmode_delayTimer()
end