function vexalarm.panel_profiles()
	return {
		type = "group",
		args = {
			grpadd = {
				name = "Save current settings",
				order=1, type ="group", dialogInline = true,
				args = {
					profile_new = {
						name = "Name",
						order=1, type = "input", width="double",
						set = function(info,val) vexalarm_optionTab_Profiles_new = val vexalarm_initialize(true) end,
						get = function() return vexalarm_optionTab_Profiles_new end,
						},
					profile_new_add = {
						name = "save",
						order=2, type = "execute", width="half",
						disabled = not(vexalarm_optionTab_General_checkName(vexalarm_optionTab_Profiles_new)),
						func = function(info,val) vexalarm_optionTab_Profiles_save() vexalarm_initialize(true) end,
						confirm = vexalarm_p[vexalarm_optionTab_Profiles_new]~= nil,
						confirmText = "A profile with that name allready exists. Do you want to overwrite it ?",
						},
					status = {name = vexalarm_optionTab_Profiles_statusMsg["save"], type = "description", order=10},
					},
				},
			space1 = {name =" ", type = "description", order=4},
			grpdelete = {
				name = "Load, delete, rename",
				order=5, type ="group", dialogInline = true,
				args = {
					profile = {
						name = "Existing profiles",
						order=1, type = "select", style = "dropdown", width="double",
						values = vexalarm_optionTab_Profiles_getList(true),
						set = function(self,key)
							vexalarm_optionTab_Profiles_profile = key
							vexalarm_optionTab_Profiles_newname = key
							vexalarm_initialize(true)
							end,
						get = function() return vexalarm_optionTab_Profiles_profile end,
						},
					--space1 = {name =" ", type = "description", order=10},
					load_exe_all = {
						name = "load all",
						order=11, type = "execute",
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_Profiles_getList(), vexalarm_optionTab_Profiles_profile),
						func = function(info,val) vexalarm_optionTab_Profiles_load("all") vexalarm_initialize(true) end,
						},
					load_exe_settings = {
						name = "load settings",
						order=12, type = "execute",
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_Profiles_getList(), vexalarm_optionTab_Profiles_profile),
						func = function(info,val) vexalarm_optionTab_Profiles_load("data") vexalarm_initialize(true) end,
						},
					load_exe_frames = {
						name = "load frames",
						order=13, type = "execute",
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_Profiles_getList(), vexalarm_optionTab_Profiles_profile),
						func = function(info,val) vexalarm_optionTab_Profiles_load("f_data") vexalarm_initialize(true) end,
						},
					load_exe_spells = {
						name = "load spell data",
						order=14, type = "execute",
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_Profiles_getList(), vexalarm_optionTab_Profiles_profile),
						func = function(info,val) vexalarm_optionTab_Profiles_load("spelldata")  vexalarm_initialize(true) end,
						},
					status_load = {name = vexalarm_optionTab_Profiles_statusMsg["load"], type = "description", order=29},
					space4 = {name =" ", type = "description", order=30},
					newname = {
						name = "New name",
						order=31, type = "input", width="double",
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_Profiles_getList(), vexalarm_optionTab_Profiles_profile),
						set = function(info,val) vexalarm_optionTab_Profiles_newname = val vexalarm_initialize(true) end,
						get = function() return vexalarm_optionTab_Profiles_newname end,
						},
					changename = {
						name = "change name",
						order=32, type = "execute",
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_Profiles_getList(), vexalarm_optionTab_Profiles_profile) or vexalarm_optionTab_Profiles_newname=="",
						func = function(info,val) vexalarm_optionTab_Profiles_rename() vexalarm_initialize(true) end,
						confirm = vexalarm_p[vexalarm_optionTab_Profiles_newname]~= nil,
						confirmText = "A profile with the new name allready exists. Do you want to overwrite it ?",
						},
					status_rename = {name = vexalarm_optionTab_Profiles_statusMsg["rename"], type = "description", order=33},
					space5 = {name =" ", type = "description", order=40},
					delete_exe = {
						name = "delete",
						order=41, type = "execute",
						disabled = vexalarm_optionTab_FrameSettings_getDisabled(vexalarm_optionTab_Profiles_getList(), vexalarm_optionTab_Profiles_profile),
						func = function(info,val) vexalarm_optionTab_Profiles_delete() vexalarm_initialize(true) end,
						confirm = true,
						confirmText = "Do you really want to delete this profile?"
						},
					status_delete = {name = vexalarm_optionTab_Profiles_statusMsg["delete"], type = "description", order=42},
					},
				},
			}
		}
end








