function vexalarm.panel_spells()
	local grps = {"Buffs", "Selfbuffs", "Groupbuffs", "Casts with targets", "Casts without targets"}
	local printableClassnames = {"DeathKnight", "Druid", "Hunter", "Mage", "Monk", "Paladin", "Priest", "Rogue", "Shaman", "Warlock", "Warrior", "no class"}
	local classnames = {"DEATHKNIGHT", "DRUID", "HUNTER", "MAGE", "MONK", "PALADIN", "PRIEST", "ROGUE", "SHAMAN", "WARLOCK", "WARRIOR", ""}
	local rolenames = {"all", "tank", "heal", "dd", "role not set"}
	local orderStartvalue = 100
	local enable = {
		{"+", "enable", true},
		{"-", "disable", false}}
	local definitiontexts = {
		"Buffs that have a single target",
		"Buffs that have no target and are mostly casted on yourself",
		"Buffs that effect multiple targets",
		"Casts that have a target",
		"Casts that have no target and are mostly casted on yourself"}
	local rank = 0
	local spelltypes = {"buff", "selfbuff", "grpbuff", "instant", "instantself"}
	
	local options = {
		type = "group",
		args = {
			eventtypegrp = {
				name = "Filter",
				type="group", order= 2, dialogInline = true,
				args = {
					classes = {
						name = "Class",
						order = 1, type ="select",
						values = {
							[0] = "All classes",
							[1] = "Non class-specific",
							[2] = "|CFF"..vexalarm_ClassColorHex("DEATHKNIGHT").."DeathKnight|r",
							[3] = "|CFF"..vexalarm_ClassColorHex("DRUID").."Druid|r",
							[4] = "|CFF"..vexalarm_ClassColorHex("HUNTER").."Hunter|r",
							[5] = "|CFF"..vexalarm_ClassColorHex("MAGE").."Mage|r",
							[6] = "|CFF"..vexalarm_ClassColorHex("MONK").."Monk|r",
							[7] = "|CFF"..vexalarm_ClassColorHex("PALADIN").."Paladin|r",
							[8] = "|CFF"..vexalarm_ClassColorHex("PRIEST").."Priest|r",
							[9] = "|CFF"..vexalarm_ClassColorHex("ROGUE").."Rogue|r",
							[10] = "|CFF"..vexalarm_ClassColorHex("SHAMAN").."Shaman|r",
							[11] = "|CFF"..vexalarm_ClassColorHex("WARLOCK").."Warlock|r",
							[12] = "|CFF"..vexalarm_ClassColorHex("WARRIOR").."Warrior|r"},
						set = function(info,key) vexalarm_optionTab_Spells_setFilter("class", key) vexalarm_initialize(true) end,
						get = function() return vexalarm_optionTab_Spells_GetClassFilter() end,
						},
					eventtypes = {
						name = "Spelltype",
						order =2, type ="select",
						values = {
							[0] = "All spelltypes",
							[1] = "Buffs",
							[2] = "Selfbuffs",
							[3] = "Groupbuffs",
							[4] = "Casts with targets",
							[5] = "Casts without targets"},
						set = function(info,key) vexalarm_optionTab_Spells_setFilter("spelltype", key) vexalarm_initialize(true) end,
						get = function() return vexalarm_optionTab_Spells_eventType end,
						},
					name = {
						name = "Name",
						order=3, type = "input", multiline = false,
						set = function(info,val) vexalarm_optionTab_Spells_name = val vexalarm_initialize(true) end,
						get = function() return vexalarm_optionTab_Spells_name end
						},
					status = {name = vexalarm_optionTab_Spells_statusMsg, type = "description", order=10},
					spells = {
						name = "Spells to adjust:",
						order =11, type ="select", width="double",
						values = vexalarm_optionTab_SpellProfiles_getList(true,true),
						set = function(info,key) vexalarm_optionTab_Spells_SP = key vexalarm_initialize(true) end,
						get = function() return vexalarm_optionTab_Spells_SP end,
						},	
					}
				}
			}
		}
	
	local optiongrp = {
		name = "Toggle Settings", type = "group", dialogInline = true, args = {}, order=10,
		}
		
	
	-- +/- buttons
	local role = 0
	for i=1,5 do
		for j=1,2 do
			if i == 1 then 	role = nil		rank = (j*15)+1
			else 			role = i-1 		rank = i+(10*j) end
			optiongrp.args[tostring(vexalarm_optionTab_Spells_eventType).."_"..enable[j][2].."_role_"..tostring(i)] = vexalarm_optionTab_Spells_getButton(rolenames[i], enable[j], role, rank)
		end
	end
	
	options.args["buttons"] = optiongrp
	
	if vexalarm_optionTab_Spells_class == 0 and vexalarm_optionTab_Spells_eventType == 0 then
		for event=1, 5 do
			for class=1, 12 do
				local spellrank = 0
				local spelllist = vexalarm_optionTab_Spells_getAlphSpellist(spelltypes[event], classnames[class])
				local spellclassgrp = { name = grps[event]..": "..printableClassnames[class], type = "group", dialogInline = true, args = {}, order=orderStartvalue+(event*20)+class}
				for j in ipairs(spelllist) do
					local key = spelllist[j][2]
					spellrank = spellrank + 1
					rank = (spellrank*10)+orderStartvalue
					
					spellclassgrp.args[tostring(rank)] = vexalarm_optionTab_Spells_getDescription(key, rank)
					spellclassgrp.args[tostring(rank+1)] = vexalarm_optionTab_Spells_getToolTipButton(key, rank+1, printableClassnames[class], classnames[class], spelltypes[event])
					for z=1,4 do
						spellclassgrp.args[tostring(rank+z+1)] = vexalarm_optionTab_Spells_getToggle(rolenames[z+1], key, z, rank+z+1)
					end
							
					if j ~= #spelllist then spellclassgrp.args[tostring(rank+6)] = {name = "\n", type="description", order=rank+6} end	
				end
				if spellrank > 0 then
					options.args["spells"..event..class] = spellclassgrp
				end
			end
		end
	elseif vexalarm_optionTab_Spells_eventType == 0 then
		for i=1, 5 do
			local spellrank = 0
			local spelllist = vexalarm_optionTab_Spells_getAlphSpellist(spelltypes[i], classnames[vexalarm_optionTab_Spells_class])
			local spellclassgrp = { name = printableClassnames[vexalarm_optionTab_Spells_class]..": "..grps[i], type = "group", dialogInline = true, args = {}, order=orderStartvalue+i}
			for j in ipairs(spelllist) do
				local key = spelllist[j][2]
				spellrank = spellrank + 1
				rank = (spellrank*10)+orderStartvalue
				
				spellclassgrp.args[tostring(rank)] = vexalarm_optionTab_Spells_getDescription(key, rank)
				spellclassgrp.args[tostring(rank+1)] = vexalarm_optionTab_Spells_getToolTipButton(key, rank+1, printableClassnames[vexalarm_optionTab_Spells_class], classnames[vexalarm_optionTab_Spells_class], spelltypes[i])
				
				for z=1,4 do
					spellclassgrp.args[tostring(rank+z+1)] = vexalarm_optionTab_Spells_getToggle(rolenames[z+1], key, z, rank+z+1)
				end
						
				if j ~= #spelllist then spellclassgrp.args[tostring(rank+6)] = {name = "\n", type="description", order=rank+6} end	
			end
			if spellrank > 0 then
				options.args["spells"..i] = spellclassgrp
			end
		end
	elseif vexalarm_optionTab_Spells_class == 0 then
		for i=1, 12 do
			local spellrank = 0
			local spelllist = vexalarm_optionTab_Spells_getAlphSpellist(spelltypes[vexalarm_optionTab_Spells_eventType], classnames[i])
			local spellclassgrp = { name = grps[vexalarm_optionTab_Spells_eventType]..": "..printableClassnames[i], type = "group", dialogInline = true, args = {}, order=orderStartvalue+i}
			for j in ipairs(spelllist) do
				local key = spelllist[j][2]
				spellrank = spellrank + 1
				rank = (spellrank*10)+orderStartvalue
				
				spellclassgrp.args[tostring(rank)] = vexalarm_optionTab_Spells_getDescription(key, rank)
				spellclassgrp.args[tostring(rank+1)] = vexalarm_optionTab_Spells_getToolTipButton(key, rank+1, printableClassnames[i], classnames[i], spelltypes[vexalarm_optionTab_Spells_eventType])
				
				for z=1,4 do
					spellclassgrp.args[tostring(rank+z+1)] = vexalarm_optionTab_Spells_getToggle(rolenames[z+1], key, z, rank+z+1)
				end
						
				if j ~= #spelllist then spellclassgrp.args[tostring(rank+6)] = {name = "\n", type="description", order=rank+6} end	
			end
			if spellrank > 0 then
				options.args["spells"..i] = spellclassgrp
			end
		end
	else
		local spellrank = 0
		local spelllist = vexalarm_optionTab_Spells_getAlphSpellist(spelltypes[vexalarm_optionTab_Spells_eventType], classnames[vexalarm_optionTab_Spells_class])
		local spellclassgrp = { name = printableClassnames[vexalarm_optionTab_Spells_class], type = "group", dialogInline = true, args = {}, order=orderStartvalue}
		for j in ipairs(spelllist) do
			local key = spelllist[j][2]
			spellrank = spellrank + 1
			rank = (spellrank*10)+orderStartvalue
			
			spellclassgrp.args[tostring(rank)] = vexalarm_optionTab_Spells_getDescription(key, rank)
			spellclassgrp.args[tostring(rank+1)] = vexalarm_optionTab_Spells_getToolTipButton(key, rank+1, printableClassnames[vexalarm_optionTab_Spells_class], classnames[vexalarm_optionTab_Spells_class], spelltypes[vexalarm_optionTab_Spells_eventType])
			
			for z=1,4 do
				spellclassgrp.args[tostring(rank+z+1)] = vexalarm_optionTab_Spells_getToggle(rolenames[z+1], key, z, rank+z+1)
			end
					
			if j ~= #spelllist then spellclassgrp.args[tostring(rank+6)] = {name = "\n", type="description", order=rank+6} end	
		end
		options.args["spells"..vexalarm_optionTab_Spells_class] = spellclassgrp
	end

	return options
end
